datablock FxDTSBrickData(BrickStraightWireData : Brick1x1Data)
{
  uiName = "Straight Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/straight.blb";
	isPower = 1;
  isWire = 1;
  directions = "1 3";
};

datablock FxDTSBrickData(BrickTurnWireData : Brick1x1Data)
{
  uiName = "Turn Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/turn.blb";
	isPower = 1;
  isWire = 1;
  orientationFix = 2;
  directions = "0 1";
};

datablock FxDTSBrickData(BrickForkWireData : Brick1x1Data)
{
  uiName = "Fork Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/t.blb";
	isPower = 1;
  isWire = 1;
  orientationFix = 1;
  directions = "0 1 2";
};

datablock FxDTSBrickData(BrickCrossWireData : Brick1x1Data)
{
  uiName = "Cross Wire";
  category = "Power";
  subCategory = "Wires";
  brickFile = "./bricks/x.blb";
	isPower = 1;
  isWire = 1;
  directions = "0 1 2 3";
};

datablock FxDTSBrickData(BrickANDGateData : Brick1x1Data)
{
  uiName = "AND Gate";
  category = "Power";
  subCategory = "Gates";
  brickFile = "./bricks/andgate.blb";
  orientationFix = 1;
  isPower = 1;
  isGate = 1;
};

datablock FxDTSBrickData(BrickORGateData : Brick1x1Data)
{
  uiName = "OR Gate";
  category = "Power";
  subCategory = "Gates";
  brickFile = "./bricks/orgate.blb";
  orientationFix = 1;
  isPower = 1;
  isGate = 1;
};

datablock FxDTSBrickData(BrickXORGateData : Brick1x1Data)
{
  uiName = "XOR Gate";
  category = "Power";
  subCategory = "Gates";
  brickFile = "./bricks/orgate.blb";
  orientationFix = 1;
  isPower = 1;
  isGate = 1;
};

datablock FxDTSBrickData(Brick1WGenData : Brick1x1Data)
{
  uiName = "1W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 1;
};

datablock FxDTSBrickData(Brick5WGenData : Brick1x1Data)
{
  uiName = "5W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 5;
};

datablock FxDTSBrickData(Brick10WGenData : Brick1x1Data)
{
  uiName = "10W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 10;
};

datablock FxDTSBrickData(Brick25WGenData : Brick1x1Data)
{
  uiName = "25W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 25;
};

datablock FxDTSBrickData(Brick50WGenData : Brick1x1Data)
{
  uiName = "50W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 50;
};

datablock FxDTSBrickData(Brick100WGenData : Brick1x1Data)
{
  uiName = "100W Gen";
  category = "Power";
  subCategory = "Generators";
  isPower = 1;
  isGen = 1;
  output = 100;
};

function FxDTSBrickData::onWirePlant(%this, %obj)
{
  WireGroup.add(%obj);
}

function FxDTSBrickData::onGenPlant(%this, %obj)
{
  GenGroup.add(%obj);
}

function FxDTSBrickData::onGatePlant(%this, %obj)
{
  GateGroup.add(%obj);
}

function FxDTSBrickData::onPowerPlant(%this, %obj)
{
  %links = %obj.getPowerLinks();
  %count = getWordCount(%links);

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (isObject(%link) && (%link.power > 0 || %link.getDataBlock().isGen))
      updatePower(%link);
  }

  updatePower(%obj);

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (isObject(%link) && (%link.power <= 0 && !%link.getDataBlock().isGen))
      updatePower(%link);
  }
}

function FxDTSBrickData::onPowerRemoved(%this, %obj)
{
  %links = %obj.getPowerLinks();
  %count = getWordCount(%links);

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (isObject(%link) && %link.source == %obj)
    {
      %link.setPower(0, 0);
      updatePower(%link);
    }
  }
}

package WireBricksPackage
{
  function FxDTSBrickData::onPlant(%this, %obj)
  {
    Parent::onPlant(%this, %obj);

    if (%this.isPower)
    {
      if (%this.isWire)
        %this.onWirePlant(%obj);

      if (%this.isGen)
        %this.onGenPlant(%obj);

      if (%this.isGate)
        %this.onGatePlant(%obj);

      %this.onPowerPlant(%obj);
    }
  }

  function FxDTSBrickData::onLoadPlant(%this, %obj)
  {
    Parent::onLoadPlant(%this, %obj);

    if (%this.isPower)
    {
      if (%this.isWire)
        %this.onWirePlant(%obj);

      if (%this.isGen)
        %this.onGenPlant(%obj);

      if (%this.isGate)
        %this.onGatePlant(%obj);

      %this.onPowerPlant(%obj);
    }
  }

  function FxDTSBrick::onRemove(%this)
  {
    if (isObject(%this.shape))
      %this.shape.delete();

    if (%this.isPlanted())
    {
      %db = %this.getDataBlock();

      if (%db.isPower)
        %db.onPowerRemoved(%this);
    }

    Parent::onRemove(%this);
  }

  function FxDTSBrick::onDeath(%this)
  {
    if (isObject(%this.shape))
      %this.shape.delete();

    if (%this.isPlanted())
    {
      %db = %this.getDataBlock();

      if (%db.isPower)
        %db.onPowerRemoved(%this);
    }

    Parent::onDeath(%this);
  }

  function FxDTSBrick::setRayCasting(%this, %bool)
  {
    %old = %this.isRayCasting();
    Parent::setRayCasting(%this, %bool);

    if (%this.getDataBlock().isWire && %bool != %old)
    {
      if (%bool)
      {
        if (isObject(%this.source))
          updatePower(%this.source);
      }
      else
      {
        %this.setPower(0, 0);
        updatePower(%this);
      }
    }
  }
};

activatePackage("WireBricksPackage");

function BrickORGateData::processGate(%this, %obj, %count)
{
  return 1;
}

function BrickXORGateData::processGate(%this, %obj, %count)
{
  return %count == 1;
}

function BrickANDGateData::processGate(%this, %obj, %count)
{
  return %count >= 2;
}
