function FxDTSBrick::sendPower(%this, %n)
{
  %db = %this.getDataBlock();

  if (%db.isGen)
    %power = %db.output;
  else if (%db.isWire)
    %power = %this.power - 0.01;
  else
    %power = 0;

  if (%this.isDead() || %this.isFakeDead() || %power <= 0)
    return;

  %box = %this.getWorldBox();
  %box = vectorSub(getWords(%box, 3, 5), getWords(%box, 0, 2));
  %box = vectorScale(%box, 1.25);

  initContainerBoxSearch(
    %this.getWorldBoxCenter(),
    %box, $TypeMasks::FxBrickObjectType
  );

  while (isObject(%obj = containerSearchNext()))
  {
    if (%obj == %this)
      continue;

    if (!%obj.getDataBlock().isWire && !%obj.getDataBlock().isGate)
      continue;

    if (%obj.isDead() || %obj.isFakeDead() || %obj.power > 0)
      continue;

    if (!%this.isDiagonalTo(%obj) || %obj == %this.source)
      continue;

    %list = appendWord(%list, %obj);
  }

  %count = getWordCount(%list);
  %power /= %count;

  if (%list $= "")
    return "";

    %proj = new Projectile()
    {
      datablock=pongprojectile;
      initialposition=vectoradd(%obj.position,"0 0 0.7");
      initialvelocity="0 0 0.3";
    };
    missioncleanup.add(%proj);

  %result = "";

  for (%i = 0; %i < %count; %i++)
  {
    %obj = getWord(%list, %i);
    %db = %obj.getDataBlock();

    if (%db.isGate)
    {
      %result = appendWord(%result, %obj);

      %dir = vectorNormalize(vectorSub(%obj.position, %this.position));
      %obj.powers = appendWord(%obj.powers, %power);
    }
    else if (%db.isWire)
    {
      %obj.setPower(%power, %this);
      %result = appendWord(%result, %obj);
    }
    else
      %obj.fireRelay(%obj.client);
  }

  return %result;
}

function FxDTSBrick::sendPower(%this, %n)
{
  %db = %this.getDataBlock();

  if (%db.isGen)
    %power = %db.output;
  else if (%db.isWire)
    %power = %this.power - 0.01;
  else
    %power = 0;

  if (%this.isDead() || %this.isFakeDead())
    return "";

  %links = %this.getPowerLinks();

  if (%links $= "")
    return "";

  %count = getWordCount(%links);

  for (%i = %count - 1; %i >= 0; %i--)
  {
    %link = getWord(%links, %i);

    if (%link == %this.source)
      %links = removeWord(%links, %i);
  }

  if (%links $= "")
    return "";

  %count = getWordCount(%links);
  %power /= %count;

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (%link.onPowerReceived(%this, %power))
      %result = appendWord(%result, %link);
  }

  return %result;
}

function FxDTSBrick::processWire(%this)
{
  %db = %this.getDataBlock();

  if (%db.isGen)
    %power = %db.output;
  else if (%db.isWire)
    %power = %this.power;
  else
    return "";

  %power -= 0.01;

  if (%power < 0)
    %power = 0;

  if (%this.isDead() || %this.isFakeDead())
    return "";

  %links = %this.getPowerLinks();
  %count = getWordCount(%links);

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (isObject(%link) && %link == %this.source)
    {
      %links = removeWord(%links, %i);
      %count--;

      break;
    }
  }

  %power /= %count;

  for (%i = 0; %i < %count; %i++)
  {
    %link = getWord(%links, %i);

    if (isObject(%link) && %link.onPowerReceived(%this, %power))
    {
      //if (%db.isGen)
        //talk("generator sent power to " @ %link);
      %list = appendWord(%list, %link);
    }
  }

  return %list;
}

function FxDTSBrick::setPower(%this, %power, %source)
{
  %this.power = getMax(%power, 0);
  %this.source = %source;

  %this.setColorFX(%this.power <= 0 ? 0 : 3);
  %this.setColor(%this.power <= 0 ? 50 : 3);
}

function FxDTSBrick::onPowerReceived(%this, %obj, %power)
{
  if (%this.power < 0 && %power < 0)
  {
    return 0;
  }

  // if (%this.power > 0 && %power > 0)
  // {
  //   %power += %this.power;
  // }

  %vec = vectorSub(%this.getRayPos(), %obj.getRayPos());
  %vec = vectorNormalize(%vec);

  %sum = getWord(%vec, 0) + getWord(%vec, 1) + getWord(%vec, 2);

  if (mAbs(%sum) != 1 || getWord(%vec, 2) != 0)
    return 0;

  switch$ (%vec)
  {
    case "1 0 0": %dir = 0;
    case "0 -1 0": %dir = 1;
    case "-1 0 0": %dir = 2;
    case "0 1 0": %dir = 3;
  }

  if (%dir $= "")
    return;

  %dir += %this.getDataBlock().orientationFix;
  %dir -= %this.angleID;

  if (%dir < 0)
    %dir += 4;

  if (%dir >= 4)
    %dir -= 4;

  if (%this.getDataBlock().isWire)
  {
    %this.setPower(%power, %obj);
    return 1;
  }

  if (%this.getDataBlock().isGate)
  {
    if (%dir == 0)
      return 0;

    %this.input[%dir] = %power;
    return 1;
  }

  %this.fireRelay(%this.client);
  return 0;
}

function updatePower(%obj, %p)
{
  if (0 && (!%p || %obj.getDataBlock().isGate))
  {
    for (%i = 0; %i < GenGroup.getCount(); %i++)
    {
      updatePower(GenGroup.getObject(%i), 1);
    }

    return;
  }

  if (!isEventPending($PowerUpdateTick))
    $PowerUpdateTick = schedule(0, 0, powerUpdateTick);

  $PowerUpdateQueue = appendWord($PowerUpdateQueue, %obj);
}

function powerUpdateTick()
{
  cancel($PowerUpdateTick);

  if ($PowerUpdateQueue $= "")
    return;

  %obj = getWord($PowerUpdateQueue, 0);
  $PowerUpdateQueue = removeWord($PowerUpdateQueue, 0);

  if (isObject(%obj))
  {
    %db = %obj.getDataBlock();

    // %proj = new Projectile()
    // {
    //   datablock=gunprojectile;
    //   initialposition=vectoradd(%obj.position,"0 0 0.7");
    //   initialvelocity="0 0 0.3";
    // };
    // missioncleanup.add(%proj);

    if (%db.isGate)
      %new = %obj.processGate();
    else if (%db.isWire || %db.isGen)
      %new = %obj.processWire(%n);

    $PowerUpdateQueue = appendWord($PowerUpdateQueue, %new);
  }

  clientCmdBottomPrint(%obj SPC getWordCount($PowerUpdateQueue), 0.2, 1);
  //$PowerUpdateTick = schedule(0, 0, powerUpdateTick);
  //$PowerUpdateTick = schedule(200, 0, powerUpdateTick);
  $PowerUpdateTick = schedule(16, 0, powerUpdateTick);
}


function FxDTSBrick::processGate(%this)
{
  %db = %this.getDataBlock();

  %power = 0;
  %count = 0;

  for (%i = 1; %i <= 3; %i++)
  {
    if (%this.input[%i] > 0)
      %count++;

    %power += %this.input[%i];
  }

  %logic = %db.processGate(%this, %count);
  %power *= mClampF(%logic, 0, 1);

  if (isObject(%this.shape))
    %this.shape.setShapeName(%logic);

  %this.output = %power;
  %power -= 0.01;

  %pos = %this.getRayPos();
  %dir = vectorScale(%this.getRayVec(), 0.5);

  %ray = containerRayCast(
    %pos, vectorAdd(%pos, %dir),
    $TypeMasks::FxBrickObjectType, %this
  );

  if (!%ray)
    return "";

  %col = getWord(%ray, 0);

  if (%col.onPowerReceived(%this, %power))
    return %col;

  return "";
}
