// forceRequiredAddOn("Brick_HorizPoles");
// forceRequiredAddOn("Brick_PoleAdapters");

exec("./vizard.cs");

function clearShapes()
{
	for (%i = 0; %i < MissionCleanup.getCount(); %i++)
	{
		%object = MissionCleanup.getObject(%i);

		if (%object.getClassName() $= "StaticShape")
		{
			%object.delete();
			%i--;
		}
	}
}

datablock StaticShapeData(EmptyShapeData)
{
  shapeFile = "base/data/shapes/empty.dts";
};

package WirePackage
{
  function FxDTSBrickData::onPlant(%this, %obj)
  {
    Parent::onPlant(%this, %obj);

    if (%this.isWire)
      %this.onWirePlant(%obj);

    if (%this.isGen)
      %this.onGenPlant(%obj);
  }

  function FxDTSBrickData::onLoadPlant(%this, %obj)
  {
    Parent::onLoadPlant(%this, %obj);

    if (%this.isWire)
      %this.onWirePlant(%obj);

    if (%this.isGen)
      %this.onGenPlant(%obj);
  }

  function FxDTSBrick::onRemove(%this)
  {
    if (isObject(%this.shape))
      %this.shape.delete();

    Parent::onRemove(%this);
  }

  function FxDTSBrick::onDeath(%this)
  {
    if (isObject(%this.shape))
      %this.shape.delete();

    Parent::onDeath(%this);
  }
};

activatePackage("WirePackage");

function FxDTSBrickData::onWirePlant(%this, %obj)
{
  WireGroup.add(%obj);

  %obj.shape = new StaticShape()
  {
    datablock = EmptyShapeData;
  };

  // %z = getWord(%obj.getWorldBox(), 5);
  // %p = %obj.getWorldBoxCenter();

  // %pos = setWord(%p, 2, %z + 0.5);
  // %pos = %p;
  // %pos = vectorAdd(%obj.getPosition(), "0 0 1");

  // MissionCleanup.add(%obj.shape);

  %obj.shape.setTransform(vectorAdd(%obj.getPosition(), "0 0 0.3"));
  %obj.shape.setShapeName("");
  %obj.shape.setShapeNameDistance(20);
}

function FxDTSBrickData::onGenPlant(%this, %obj)
{
  %obj.genTick = %obj.schedule(50, genTick);
}

function FxDTSBrick::sendPower(%this, %power)
{
  %box = %this.getWorldBox();
  %box = vectorSub(getWords(%box, 3, 5), getWords(%box, 0, 2));
  %box = vectorScale(%box, 1.25);

  initContainerBoxSearch(
    %this.getWorldBoxCenter(),
    %box, $TypeMasks::FxBrickObjectType
  );

  while (isObject(%obj = containerSearchNext()))
  {
    if (%obj == %this)
      continue;

    if (!%obj.getDataBlock().isWire || %obj.state == 1)
      continue;

    if (%obj.isDead() || %obj.isFakeDead())
      continue;

    if (!%this.isDiagonalTo(%obj))
      continue;

    %count++;
  }

  %power /= %count;

  initContainerBoxSearch(
    %this.getWorldBoxCenter(),
    %box, $TypeMasks::FxBrickObjectType
  );

  while (isObject(%obj = containerSearchNext()))
  {
    if (%obj == %this)
      continue;

    if (!%obj.getDataBlock().isWire || %obj.state == 1)
      continue;

    if (%obj.isDead() || %obj.isFakeDead())
      continue;

    if (!%this.isDiagonalTo(%obj))
      continue;

    if (%obj.state == 2)
    {
      %obj.power += %power;
      %obj.shape.setShapeName(%obj.power);
    }
    else
      %obj.setPower(%power);
  }
}

function FxDTSBrick::setPower(%this, %power)
{
  if (%power <= 0 || %this.state)
    return;

  %this.power = %power;
  %this.state = 2;

  %this.shape.setShapeName(%power);

  %this.setColorFX(3);
  %this.setColor(18);

  %this.schedule(250, powerSchedule1);
}

function FxDTSBrick::powerSchedule1(%this)
{
  %this.sendPower(getMax(%this.power - 0.01, 0));

  %this.setColorFX(0);
  %this.setColor(0);

  %this.shape.setShapeName("");
  %this.shape.setShapeNameDistance(20);

  %this.power = 0;
  %this.state = 1;

  %this.schedule(250, powerSchedule2);
}

function FxDTSBrick::powerSchedule2(%this)
{
  %this.state = 0;
  %this.setColor(54);
}

function FxDTSBrick::genTick(%this)
{
  cancel(%this.genTick);
  %this.sendPower(10);
  //%this.genTick = %this.schedule(50, genTick);
  //%this.genTick = %this.schedule(250, genTick);
  %this.genTick = %this.schedule(2000, genTick);
}

function FxDTSBrick::isDiagonalTo(%this, %obj)
{
  %vector = vectorNormalize(vectorSub(%obj.position, %this.position));
  %sum = getWord(%vector, 0) + getWord(%vector, 1) + getWord(%vector, 2);

  return mAbs(%sum) == 1;
}

// datablock FxDTSBrickData(Brick1xHorizWireData)
// {
//   brickFile = "./bricks/1xHorizWire.blb";
//   uiName = "1x Horiz Wire";
//   iconName = "Add-ons/Brick_HorizPoles/1x1HorizPole";
//   category = "Special";
//   subCategory = "Wires";
//   isWire = 1;
// };

datablock FxDTSBrickData(BrickWireData : Brick1x1Data)
{
  uiName = "Wire";
  category = "Special";
  subCategory = "Wires";
  isWire = 1;
};

datablock FxDTSBrickData(BrickGeneratorData : Brick1x1Data)
{
  uiName = "20Hz 10W Gen";
  category = "Special";
  subCategory = "Wires";
  isGen = 1;
};

if (!isObject(WireGroup))
  new SimSet(WireGroup);
