exec("./bricks.cs");
exec("./power.cs");

function clearShapes()
{
	for (%i = 0; %i < MissionCleanup.getCount(); %i++)
	{
		%object = MissionCleanup.getObject(%i);

		if (%object.getClassName() $= "StaticShape")
		{
			%object.delete();
			%i--;
		}
	}
}

datablock StaticShapeData(EmptyShapeData)
{
  shapeFile = "base/data/shapes/empty.dts";
};

function FxDTSBrick::getRayPos(%this)
{
  %z = getWord(%this.getWorldBox(), 2);
  %z += 0.1;

  %pos = %this.getPosition();
  %pos = setWord(%pos, 2, %z);

  return %pos;
}

function FxDTSBrick::getRayVec(%this, %angle)
{
  %angle += %this.angleID;
  %angle += %this.getDataBlock().orientationFix;
  %angle %= 4;

  switch (%angle)
  {
    case 0: return "1 0 0";
    case 1: return "0 -1 0";
    case 2: return "-1 0 0";
    case 3: return "0 1 0";
  }

  return "0 0 0";
}

function FxDTSBrick::getPowerLinks(%this)
{
  %pos = %this.getRayPos();
  %dirs = %this.getWireDirs();

  %count = getFieldCount(%dirs);

  for (%i = 0; %i < %count; %i++)
  {
    %dir = getField(%dirs, %i);
    %path = vectorScale(%dir, 0.5);

    %ray = containerRayCast(
      %pos, vectorAdd(%pos, %path),
      $TypeMasks::FxBrickObjectType, %this
    );

    %col = getWord(%ray, 0);

    if (!%col || !%col.getDataBlock().isPower)
      continue;

    if (%col.isDead() || %col.isFakeDead())
      continue;

    %test = %col.getWireDirs();

    if (!hasField(%test, multiplyWords(%dir, -1)))
      continue;

    %links = appendWord(%links, %col);
  }

  return %links;
}

function FxDTSBrick::getWireDirs(%this)
{
  %name = %this.getDataBlock().getName();
  %angle = %this.angleID;
  %angle -= %this.getDataBlock().orientationFix;

  if (%angle < 0)
    %angle += 4;

  if (%name $= "BrickStraightWireData")
  {
    return %angle % 2 == 0 ? "0 1\t0 -1" : "1 0\t-1 0";
  }

  if (%name $= "BrickForkWireData")
  {
    switch (%angle)
    {
      case 0: return "1 0\t0 1\t0 -1";
      case 1: return "0 -1\t1 0\t-1 0";
      case 2: return "-1 0\t0 1\t0 -1";
      case 3: return "0 1\t1 0\t-1 0";
    }
  }

  if (%name $= "BrickTurnWireData")
  {
    switch (%angle)
    {
      case 0: return "1 0\t0 -1";
      case 1: return "-1 0\t0 -1";
      case 2: return "-1 0\t0 1";
      case 3: return "1 0\t0 1";
    }
  }

  return "1 0\t-1 0\t0 1\t0 -1";
}

function hasField(%fields, %field)
{
  %count = getFieldCount(%fields);

  for (%i = 0; %i < %count; %i++)
    if (strStr(%field, getField(%fields, %i)) == 0)
      return 1;

  return 0;
}

function appendWord(%list, %word)
{
  if (%word $= "")
    return %list;

  if (%list $= "")
    return %word;

  return %list SPC %word;
}

function multiplyWords(%words, %scalar)
{
  %count = getWordCount(%words);

  for (%i = 0; %i < %count; %i++)
    %words = setWord(%words, %i, getWord(%words, %i) * %scalar);

  return %words;
}

package WireActivatePackage
{
  function FxDTSBrick::onActivate(%this, %obj, %client, %pos, %vec)
  {
    Parent::onActivate(%this, %obj, %client, %pos, %vec);
    %db = %this.getDataBlock();

    if (%db.isWire)
    {
      %text = "<font:palatino linotype:32>\c6" @ %db.uiName;
      %text = %text @ "\n<font:palatino linotype:24>";

      %text = %text @ "<color:FFFF77>Power\c6: <color:";
      %text = %text @ (%this.power > 0 ? "77FF77" : "FF7777") @ ">";
      %text = %text @ %this.power + 0 @ "W";
    }
    else if (%db.isGen)
    {
      %text = "<font:palatino linotype:32>\c6" @ %db.uiName;
      %text = %text @ "\n<font:palatino linotype:24>";

      %text = %text @ "<color:FFFF77>Output\c6: <color:";
      %text = %text @ (%db.output > 0 ? "77FF77" : "FF7777") @ ">";
      %text = %text @ %db.output + 0 @ "W";
    }
    else if (%db.isGate)
    {
      %text = "<font:palatino linotype:32>\c6" @ %db.uiName;
      %text = %text @ "\n<font:palatino linotype:24>";

      %text = %text @ "<color:FFFF77>Output\c6: <color:";
      %text = %text @ (%this.output > 0 ? "77FF77" : "FF7777") @ ">";
      %text = %text @ %this.output + 0 @ "W";

      for (%i = 1; %i <= 3; %i++)
      {
        %power = %this.input[%i];

        %text = %text @ "\n<color:FFFF77>Input[" @ %i @ "]\c6: <color:";
        %text = %text @ (%power > 0 ? "77FF77" : "FF7777") @ ">";
        %text = %text @ %power + 0 @ "W";
      }
    }

    if (%text !$= "")
      %client.centerPrint(%text, 3);
  }
};

activatePackage("WireActivatePackage");

if (!isObject(WireGroup))
  new SimSet(WireGroup);

if (!isObject(GenGroup))
  new SimSet(GenGroup);

if (!isObject(GateGroup))
  new SimSet(GateGroup);
